﻿using Connected.Annotations;
using Connected.ServiceModel;
using System.Collections.Immutable;

namespace Connected.Security.Identity;

[Service]
[ServiceUrl(SecurityRoutes.Users)]
public interface IUserService
{
	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<IUser>?> Query();


	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<IUser>?> Query(PrimaryKeyListArgs<int> e);


	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<IUser?> Select(PrimaryKeyArgs<int> args);


	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<IUser?> Resolve(UserResolveArgs args);


	[ServiceMethod(ServiceMethodVerbs.Post)]
	Task<int> Insert(UserInsertArgs args);


	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Patch)]
	Task Update(UserUpdateArgs args);


	[ServiceMethod(ServiceMethodVerbs.Post)]
	Task UpdatePassword(UserPasswordArgs args);


	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Delete)]
	Task Delete(PrimaryKeyArgs<int> args);
}
